local logging = require"logging"

function logging.memory()
  local log = {}
  local maxRec = 1000
  local head = 1
  local tail = 0
	
  local obj = logging.new(function(self, level, message)
    head = head - 1
    log[head] = ("%s %-5s %s"):format(os.date"%F %T", level, message)
    while tail - head >= maxRec do
      log[tail] = nil
      tail = tail - 1
    end
    return true
  end)

  obj.show = function()
    return table.concat(log, '\n', head, tail)
  end

  return obj
end

return logging

