
var NSG = {'root':window};

if (typeof (NSGVERSION) == 'undefined')
    NSGVERSION='' + Math.random()+ '';

escapeSpec = function (s) {
    return  "\""+s.replace(/(['"\\])/g,"\\$1").replace(/[\n]/g,"\\n").replace(/[\r]/g,"\\r").replace(/[\t]/g,"\\t").replace(/[\b]/g,"\\b").replace(/[\f]/g,"\\f")+"\""
}

function encodeJSString(str) {
  var result = '', index = 0, charCode, escape;
  while (!isNaN(charCode = str.charCodeAt(index++))) {
    escape = charCode.toString(16);
    result += charCode < 256
      ? '\\x' + (charCode > 15 ? '' : '0') + escape
      : '\\u' + ('0000' + escape).slice(-4);
  }
  return result;
}

htmlDecode = function (s) {
    return s.replace(/&gt;/g,">").replace(/&lt;/g, "<").replace(/&quot;/g, "\"").replace(/&amp;/g, "&");
}
htmlEncode = function (s) {
    return s.replace(/&/g, "&amp;").replace(/>/g,"&gt;").replace(/</g, "&lt;").replace(/\"/g, "&quot;");
}


function getHelp(name) {
    var res = name;
    NSG.root.LOCALE = NSG.root.LOCALE.toLowerCase();
    if (typeof (NSG.root.LOCALE) =='undefined' || NSG.root.LOCALE == "")
        NSG.root.LOCALE = "1";
    if  (typeof (name) !='undefined' && name != "") {
        if  (typeof (NSG.root.dictionary[name]) !='undefined') {
            if  (typeof (NSG.root.dictionary[name][NSG.root.LOCALE]) !='undefined')
                res = NSG.root.dictionary[name][NSG.root.LOCALE]
	    else
		if  (typeof (NSG.root.dictionary[name]["1"]) !='undefined')
                    res = NSG.root.dictionary[name]["1"];
        };
	if  (typeof (NSG.root.dictionary[name]) !='undefined') {
            if (NSG.root.dictionary[name]["1"] == "**")
		res = '['+name+']';
	}
        return res;
    } else
        return '';
}


var  createRequest = function () {
    var receiveReq = false;

    if (window.XMLHttpRequest) {
        try {
            receiveReq = new XMLHttpRequest();
        } catch (e){
            receiveReq = false;
        }
    };
    if (!receiveReq && window.ActiveXObject) {
        var xmlHttpVers = new Array('Msxml2.XMLHTTP.6.0','Msxml2.XMLHTTP.5.0','Msxml2.XMLHTTP.4.0','Msxml2.XMLHTTP.3.0','Msxml2.XMLHTTP','Microsoft.XMLHTTP');
        for(var i = 0; i < xmlHttpVers.length && !receiveReq; i++){
            try{
                receiveReq = new ActiveXObject(xmlHttpVers[i]);
            }catch(e){}
        }
    }

    if (!receiveReq)
    {
	      alert("Can\"t create XMLHttpRequest");
    };

    return receiveReq;
}

var Browser = {
    IE:   !!(window.attachEvent && !window.opera),
    Opera: !!window.opera,
    Khtml: navigator.userAgent.indexOf('AppleWebKit/') > -1,
    Gecko: navigator.userAgent.indexOf('Gecko') > -1 && navigator.userAgent.indexOf('KHTML') == -1
}

xmlTransform = function (request) {
    //  var xml = typeof(request)=='string' ? request : (request.responseXML ? request.responseXML : request.responseText);
    var xml = typeof(request)=='string' ? request :  request.responseText;
    if( !window.XSLT) {
        return xml;
    }

    if(!window.XSLT) {
        alert("XSLT file not loaded! Can`t continue!");
        return xml;
    };

    var xmldoc;
    if (typeof(xml)=="string"){
        if(Browser.IE){
            xmldoc = new ActiveXObject("Microsoft.XMLDOM");
            xmldoc.async = false;
            xmldoc.loadXML(xml);
            return xmldoc.transformNode(window.XSLT);
        } else if(window.DOMParser) {
            parser=new DOMParser();
            xmldoc=parser.parseFromString(xml,"text/xml");
        } else {
            return xml;
        };
    } else {
        xmldoc = xml;
    }

    if (window.ActiveXObject)
    {
        return  xmldoc.transformNode(window.XSLT);
    }else{
        var xsltProcessor = new XSLTProcessor();
        xsltProcessor.importStylesheet(window.XSLT);
        var page = xsltProcessor.transformToFragment(xmldoc, document);
        var div = document.createElement("DIV");
        $(div).html(page);
        var html = $(div).html();
        $(div).html("");
        return  html;
    }
}

initScript = function () {
    var scripts;
    scripts = document.getElementsByTagName("div");
    for (var i=0;i<scripts.length;i++) {
        if ($(scripts[i]).hasClass("initscript")) {
            var script;
            script = scripts[i].innerHTML;
            if (script.length>0) {
                eval(script);
            }
            scripts[i].innerHTML = "";
        }
    }
}

loadXSLT = function () {
    if(Browser.IE){
        window.XSLT = new ActiveXObject("Microsoft.XMLDOM");
        window.XSLT.async = false;
	window.XSLT.validateOnParse = false;
        window.XSLT.load('/style.xsl?'+ NSGVERSION);
    }else{
        var xmlHttp = createRequest();
        if(!xmlHttp){
            return;
        }

        xmlHttp.open('GET', '/style.xsl?' + NSGVERSION, false);
        xmlHttp.onreadystatechange = function (){
            if(xmlHttp.readyState == 4 && xmlHttp.status == 200){
                var dp = new DOMParser();
                window.XSLT = dp.parseFromString(xmlHttp.responseText, "text/xml");
            }
        }
        xmlHttp.send();
    }
}

loadXSLT();

window.dictionary = window.dictionary ? window.dictionary : {};

var validatorRequestArray= {};
var taskArray = {};
var hiddenDiv = document.createElement("DIV");
var maxTimer = 8 * 60;  // maximum for request timeout in seconds
var defTimer = 20;  //default timeout
//special global variable
var execScriptsParam = null;

zeroOrText = function (s){
    if (s == "\0")
        return "";
    else
        return s;
};


incActivity = function () {
    if(typeof(activity) == "undefined")
        return;

    activity=activity + 1;
    var img = findChildByTagClass(document,"img","activityoff", 5);
    if (img) {
       $(img).removeClass("activityoff").addClass("activityon");
    } else {
        img = findChildByTagClass(document,"img","activityon", 5);
    }

    if (img) {
        img.alt = activity;
        //  img.title = "header=[" + activity + "] ";
        img.nsgTitle = "header=[webJobs] body=[" + activity + "]";
    }
}

decActivity = function () {
    if(typeof(activity) == "undefined")
        return;
    
    activity=activity - 1;
    var img = findChildByTagClass(document,"img","activityon", 5);
    if (activity<=0){
        activity=0;
        if (img) {
	    $(img).removeClass("activityon").addClass("activityoff");
        }
    }
    if (img) {
        img.alt = activity;
        // img.title = "header=[" + activity + "] ";
        img.nsgTitle = "header=[webJobs] body=[" + activity + "]";
    }
}

getCaretPos = function (el)
{
    el.focus();
    
    if(el.selectionStart) return el.selectionStart;//Gecko
    else if (document.selection)//IE
    { 
        var sel = document.body.createTextRange ();
        //var sel = document.selection.createRange();
        //var clone = sel.duplicate();
        //sel.collapse(true);
        var clone = sel;
        clone.moveToElementText(el);
        clone.setEndPoint('EndToEnd', sel);
        return clone.text.length;
    }
    
    return 0;
}

setSelectionRange = function (input, selectionStart, selectionEnd) {
    if (input.setSelectionRange) {
        input.focus();
        input.setSelectionRange(selectionStart, selectionEnd);
    }
    else if (input.createTextRange) {
        var range = input.createTextRange();
        range.collapse(true);
        range.moveEnd('character', selectionEnd);
        range.moveStart('character', selectionStart);
        range.select();
    }
}

replaceSelection = function (input, replaceString) {
	  if (input.setSelectionRange) {
		    var selectionStart = input.selectionStart;
		    var selectionEnd = input.selectionEnd;
		    input.value = input.value.substring(0, selectionStart)+ replaceString + input.value.substring(selectionEnd);
        
		    if (selectionStart != selectionEnd){ 
			      setSelectionRange(input, selectionStart, selectionStart + 	replaceString.length);
		    }else{
			      setSelectionRange(input, selectionStart + replaceString.length, selectionStart + replaceString.length);
		    }

	  }else if (document.selection) {
		    var range = document.selection.createRange();

		    if (range.parentElement() == input) {
			      var isCollapsed = range.text == '';
			      range.text = replaceString;

			      if (!isCollapsed)  {
				        range.moveStart('character', -replaceString.length);
				        range.select();
			      }
		    }
	  }
}

setCookie = function (name, value, expires, path, domain, secure) {
 /*   if (!expires) {
        expires = new Date();
        expires.setTime(expires.getTime() + (1000 * 86400 * 365));
        expires = expires.toGMTString();
    }*/
    document.cookie = name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires : "")  +
        ((path) ? "; path=" + path : "; path=/") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
};

getCookie = function (name) {
	  var cookie = " " + document.cookie;
	  var search = " " + name + "=";
	  var setStr = null;
	  var offset = 0;
	  var end = 0;
	  if (cookie.length > 0) {
		    offset = cookie.indexOf(search);
		    if (offset != -1) {
			      offset += search.length;
			      end = cookie.indexOf(";", offset)
			      if (end == -1) {
				        end = cookie.length;
			      }
			      setStr = unescape(cookie.substring(offset, end));
		    }
	  }
	  return(setStr);
}

delCookie = function (name) {
    setCookie(name,"","Thu, 01 Jan 1970 00:00:01 GMT;");
}

trim = function (str) {
    return ("" + str).replace( /^\s*(\S*)\s*$/ , "$1" );
}

setAttribute = function (obj, name, value){
    var attr=obj.attributes;
    var i; 
    if(attr) { 
        for ( i = attr.length; i > 0; i--) {
            if (attr[i-1].nodeName == name) {
                attr[i-1].nodeValue = value;
                return   attr[i-1].nodeValue;
            }
        }
    }
}

getAttribute = function (obj, name){
    var attr=obj.attributes;
    var i;
    if(attr) {
        for ( i = attr.length; i > 0; i--) {
            if (attr[i-1].nodeName == name)
	              return attr[i-1].nodeValue;
        }
    }
    return "";
}

buildPath = function (eThis, type) {
	  if (eThis && eThis.parentNode && ! $(eThis).hasClass("root") ) {
        var parent = findParentByTag(eThis, "LI", 20);
        if(type == ",") {
            if(parent && ! $(parent).hasClass("root"))
                return  buildPath(parent, type) + "," + (getAttribute(eThis, "name")) + "";
            else
                return  "" + (getAttribute(eThis, "name")) + "";
        } else {
            if(parent)
                return  buildPath(parent, type) + "." + getAttribute(eThis, "name");
            else
                return  getAttribute(eThis, "name") ;
        } 
    }
	  else
		    return ""
}

getText = function (eThis) {
    var spans = eThis.getElementsByTagName("span");
    var texts;
    var text = "";
    for (var i=0;i<spans.length;i++) {
        if ($(spans[i]).hasClass("hiddentext")) {
            texts = spans[i].getElementsByTagName("textarea");
            if (texts.length>0 && $(texts[0]).hasClass("hiddentext")) {
                //alert('n:'+i+"/"+spans.length+":"+texts[i].value);
                text = text + deHex(texts[0].value);
            }
            spans[i].innerHTML = "";
        }
    }
    return text;
};

execScripts = function (eThis, param) {
    var ret;
    var sl = 0;
    $("span.hiddenscript", eThis).each(function(i1, el){
        $("textarea.hiddentext", el).each(function(i2, ta){
            window.execScriptsParam = param;
            ret = eval('[function (){' +  $(ta).val() + '}][0]')();
            sl = sl + 1;
        });
        $(el).html("");
    });
    window.execScriptsParam = null;
    if (sl == 1) {
        return ret;
    }
};


defaultAjaxFormHandler = function (responseText, statusText, xhr, form)  {
    hiddenDiv.innerHTML =  zeroOrText(xmlTransform(xhr));
    execScripts(hiddenDiv);
    var li = findParentByTag($(form)[0], "LI");
    if (li)
          updateDep(li);
    decActivity();
};

defaultAjaxFormErrorHandler = function (responseText, statusText, xhr, form)  {
    alert(getHelp("Error"));
    decActivity();
};

defaultAjaxFormBeforeSubmit = function(arr, form, options) {
    // The array of form data takes the following form:
    // [ { name: 'username', value: 'jresig' }, { name: 'password', value: 'secret' } ]
    // return false to cancel submit
    incActivity();
}

defaultAjaxFormParams = {
    success: defaultAjaxFormHandler,
    error: defaultAjaxFormErrorHandler,
    beforeSubmit: defaultAjaxFormBeforeSubmit
};


loadMenu = function (eThis) {
	  SendDataTree( eThis , "load" , true)
}

getLiClasses = function (top) {
	  var liList=top.getElementsByTagName("li");
	  var li;
	  var i;
	  var data = "";
	  for ( i = 0; i< liList.length; i++) {
		    li = liList.item(i);
		    if( li && (getAttribute(li, 'name') != "")
            && (getAttribute(li, 'name').charAt(0) == '.')
            && ( findParentByTagClass(li.firstChild, 'li', "disabled") == null )
            && ( findParentByTagClass(li.firstChild, 'li', "hidden_empty") == null )
            //&& ( findChildByTag(li, 'ul') != null )
          ) {
			      data = data + encodeURIComponent("class." + buildPath(li, ",")) + "=" + encodeURIComponent(getAttribute( li, "class")) +"&";
		    }
	  }
	  return data;
};


SendRequestAsync = function (r_method, r_path, r_args, r_handler, abortAction) {
    var path = r_path;
    var request = createRequest();
    if (!request)
    {
	      alert('ïÛÉÂËÁ! JavaScript ÎÅ ÄÁÅÔ ÓÏÚÄÁÔØ Ajax ÚÁÐÒÏÓ.');
        return null;
    }

    var requestErrFunction = function(text) {
        if(confirm(text)) {
            request.abort();
            SendRequestAsync(r_method, r_path, r_args, r_handler, abortAction);
        };
    };

    incActivity();
    r_args = r_args.replace(/&rnd=[^&]*/g,"");
    r_args += "&rnd=" + Math.random();
    if (r_method.toLowerCase() == "get" && r_args.length > 0)
        path += "?" + r_args + "&" + window.AUTH ;
    request.open(r_method, path, true);
    request.onreadystatechange = function() {
        if (request.readyState == 4) {
            decActivity();
            if((request.status == 200) || (request.status == 204)|| (typeof(request.status) == 'undefined')) {
                if (r_handler(request) == "retry"){
                    SendRequestAsync(r_method, r_path, r_args, r_handler, abortAction);
                }
            }
            else if (request.status == 0)
            { //timeout, abort or other  do nothing
                if (abortAction=="retry")
                    setTimeout(function() {SendRequestAsync(r_method, r_path, r_args, r_handler, abortAction);}, 500);
            }
            else if (request.status == 404)
                requestErrFunction("Error 404: Requested URL is not found. Try again?");
            else if (request.status == 403)
                requestErrFunction("Error 403: Access denied. Try again?");
            else
                requestErrFunction("Error " + request.status +". Try again?");
        }
    }



    if (r_method.toLowerCase() == "post")
    {
	      request.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=utf-8");
	      request.send(r_args + "&" + window.AUTH);
    }
    else
    {
	      request.send(null);
    }
	  return request;
}


findParentByTag = function (_parent, tag, maxLevel) {
    _parent = _parent.parentNode
    if( !tag || !tag.toUpperCase) {
        alert("Some error:"+tag);
    }
    if((maxLevel <= 0) || (_parent == null)) {
        return null;
    } else if( tag && _parent.nodeName.toUpperCase() == tag.toUpperCase()) {
        return _parent;
    } else if(_parent.parentNode) {
        return findParentByTag(_parent, tag, maxLevel-1)
	  } else {
        return null;
    }
    return null;
}

findParentByTagClass = function (_parent, tag, _class, maxLevel) {
    if((maxLevel <= 0) || (_parent == null) || (_parent.parentNode == null) ) {
        return null;
    }
    _parent = _parent.parentNode;
    if(_parent.nodeName.toUpperCase() == tag.toUpperCase() &&
       ($(_parent).hasClass(_class)) ) {
        return _parent;
    } else {
        return findParentByTagClass(_parent, tag, _class, maxLevel-1);
    }
    return null;
}


_findChildByTagClass = function (_parent, tag, _class, maxLevel, stopTag, stopClass) {
    if((maxLevel <= 0) 
       || (_parent == null) 
      ) {
        return {"node":null, "level":0};
    } else if(_parent.childNodes) {
        var childs = _parent.childNodes;
        var max_ret = null;
        var max_level = 0;
        var i = 0;
        for ( i = 0 ; i < childs.length; i++) {

            if(((stopTag && (childs.item(i).nodeName.toUpperCase() == stopTag.toUpperCase()))
                && (!stopClass || (stopClass && ($(childs.item(i)).hasClass(stopClass)))))) {
                // do nthing just skip it
            } else if((childs.item(i).nodeName.toUpperCase() == tag.toUpperCase()) && 
                      (!_class || ($(childs.item(i)).hasClass(_class)))) {
                return {"node":childs.item(i), "level":maxLevel};
            } else {
                res = _findChildByTagClass(childs.item(i), tag, _class, maxLevel - 1, stopTag, stopClass);
                if( res.node && (res.level > max_level) ) {
                    max_level = res.level;
                    max_ret = res.node;
                    return { "node":max_ret, "level":max_level}
                }
            }
        }
    }
    return {"node":null,"level":0};
}

findChildByTag = function (_parent, tag, maxLevel, stopTag, stopClass) {
    res= _findChildByTagClass(_parent, tag, null, maxLevel, stopTag, stopClass);
    return res.node;
}

findChildByTagClass = function (_parent, tag, _class, maxLevel, stopTag, stopClass) {
    res = _findChildByTagClass(_parent, tag, _class, maxLevel, stopTag, stopClass);
    return res.node;
}

UnHide = function ( eThis , expand){
    var li = findParentByTag(eThis, 'LI', 6);
    var ret;
    if(li) {
        if( (typeof(expand) != 'undefined' && expand>0 ) || ($(li).hasClass("cl") && ! (typeof(expand) != 'undefined' && expand==0 )) ){
            ret = ! $(li).hasClass("ex");
            $(li).removeClass("cl ex").addClass("ex");
            setCookie("LC" + buildPath(li,"."),"");
            var pleasewait = findChildByTagClass(li, "input", "pleasewait", 10, "li");
            if(pleasewait) {
                loadDir(li);
            } else {
                var runfirst = findChildByTagClass(li, "input", "runfirst", 10, "li");
                if(runfirst) {
                    var dir = findParentByTagClass(runfirst, "div", "dir",4);
                    dir.innerHTML = getHelp("runFirst");
                }
            }
        }else{
            ret =  ! $(li).hasClass("cl");
            $(li).removeClass("cl ex").addClass("cl");
            delCookie("LC" + buildPath(li,"."));
        }
    }
    return ret;
}


paramName = function (elem) { 
  /*  var table = findChildByTagClass(elem, "table", "node",  10, "ul");
    var td = findChildByTagClass(table, "td", "param",  10, "ul");
    var value = findChildByTagClass(td, "INPUT", "value",  10, "ul");
    return value.value;*/

return $("table.node:first td.param input.value", elem).val();
}

setParamValue = function (elem, val) {
    $("table.node:first td.value input.value", elem).val(val);
    $("table.node:first td.description  div.descr1",elem).html(htmlEncode(val));
    $("table.node:first td.description  div.descr2",elem).html(val && val !='' ? "<div class='descr' ondblclick='Edit(this);return false;'>" + htmlEncode(val) +"</div>" : ""); 
    $("table.node:first td.param span",elem).removeClass('configured').addClass(val && val !="" ? "configured" : "");
}

paramValue = function (elem) { 
    return $("table.node:first td.value span.normal input.value, table.node:first td.value span.dir input.value", elem).val();
}

paramStype = function (elem) { 
    var table = findChildByTagClass(elem, "table", "node",  10, "ul");
    var td = findChildByTagClass(table, "td", "param",  10, "ul");
    var value = findChildByTagClass(td, "INPUT", "stype",  10, "ul");
    return value;
}

findSibling = function (elem, tag) {
    if (!elem || !tag) return null;
    var next = elem;
    next = next.nextSibling;
    if(next) {
        if (next.nodeName && (next.nodeName.toUpperCase() == tag.toUpperCase()))
            return next
        else
            return findSibling(next, tag)
    } 
    else {
        return null;
    }
}

findPrevSibling = function (elem, tag) {
    if (!elem || !tag) return null;
    var next = elem;
    next = next.previousSibling;
    if(next) {
        if (next.nodeName && (next.nodeName.toUpperCase() == tag.toUpperCase()))
            return next
        else
            return findPrevSibling(next, tag)
    }
    else {
        return null;
    }
}

findNextElem = function ( elem) {
    var tag = elem.nodeName;
    var stype = paramStype(elem);
    var next = elem;
    do {
        next = next.nextSibling;
        nstype = paramStype(next);
    } while ( next && ((next.nodeName != tag)
                       || ((stype) && (nstype) && (stype.value != nstype.value))
                       || ((stype) && (!nstype))
                       || ((!stype) && (nstype)))
            );
    return next;
}

emptyHandler = function () {
}

FormatTime = function (t) {
    if (t<10) {
        return "0"+t;
    }
    return t;
}

findInline = function (parent) {
    var input = findChildByTagClass(parent, "input", "inline", 4);
    if(! input )  {
        input = findChildByTagClass(parent,"select", "inline", 4);
    }
    if(! input )  {
        input = findChildByTagClass(parent,"textarea", "inline", 4);
    }
    return input;
};

startEdit = function (eThis){
    var spanContainer = findParentByTagClass(eThis, "span", "reload", 4);
    if(spanContainer) {
        return;
    }
    spanContainer = findParentByTagClass(eThis, "span", "normal", 4);
    if(! spanContainer) {
        spanContainer = findParentByTagClass(eThis, "span", "disabled", 4);
    }
    if(spanContainer) {
        var caretPos =  getCaretPos(eThis);
        var input = findInline(spanContainer);
	if  (input.nodeName.toUpperCase() == "TEXTAREA") {
            input.value = input.value.replace(/"(.*)"/gm,"$1").replace(/\\+n/gm, 
								       function(str){
									   if(str.length %2 == 1)
									       return str;
									   else
									       return str.replace(/\\n/gm,"\n");
								       }).replace(/\\+"/gm, 
								       function(str){
									   if(str.length %2 == 1)
									       return str;
									   else
									       return str.replace(/\\"/gm,'"');
								       });
        }
        $(spanContainer).removeClass("reload normal disabled edit").addClass("edit");
        if(findChildByTag(input.parentNode, "select", 2) == null) {
            setSelectionRange(input, caretPos,caretPos);
        }else {
            input.focus();
        }
    }
    return false;
}

findParamName = function (eThis) {
    var li = eThis;
    if (li.nodeName.toLowerCase() != "li")
        li = findParentByTag(eThis, "li", 10);
    if(! li)
        return null;
    var a = findChildByTagClass(li, "a", "name", 7);
    return a;
}

stopEdit = function (eThis){
    var spanContainer = findParentByTagClass(eThis, "span", "edit", 4);
    if(spanContainer) {
        var lastvalue = findChildByTagClass(spanContainer, "input", "lastvalue",3);
        var tmp = eThis.onblur;
        eThis.onblur = null;
        findParamName(eThis).focus();
	$(spanContainer).removeClass("reload disabled normal edit").addClass(lastvalue.disabled ? "disabled" : "normal");
        eThis.onblur = tmp;
    }
}

inLineLongTap = function (eThis){
    var long=false;
    var timeout=window.setTimeout(function() {
        long=true;
        $(eThis).unbind("mouseup");
        startEdit(eThis);
    }, 2000);
    $(eThis).mouseup(function() {
        window.clearTimeout(timeout);
        $(eThis).unbind("mouseup");
        if(long) startEdit(eThis);
        return false; });
    return false;
}

inLineOnClick = function (eThis){
    var text = eThis.innerHTML;
    stype="_NAME";
    eThis.onclick = null;
    eThis.innerHTML="<input type=text value=\""+text+"\" onkeypress=\"return inLineOnKeyPress(this, event)\" onblur=\"return inLineOnBlur(this)\" onchange=\"return inLineOnChange(this)\">";
    eThis.getElementsByTagName("input").item(0).focus();
}

deleteItem = function (eThis, prompt) {
	  var li = findParentByTag(eThis, "LI");
    var td =  findChildByTagClass(li, "td","value", 10);
    var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");

 	  var path = buildPath(li, ",");
    abortReq(path);

    var confirm=window.confirm(prompt);

    if (confirm ) {
        var data = "&command=removeKey&path={"+encodeURIComponent(path)+"}&";
        if(li){ 
            li = findParentByTag(li, "LI");
            var Handler = function(Request)
            {
                hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                if(execScripts(hiddenDiv)=="retry")
                    return "retry";
                updateDep(li);
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
        }
    }
    return false;
}


getUsage = function (eThis) {
    var data = "&command=getUsage&";
    abortReq("getUsage");
    var a = eThis;
    var Handler = function(Request)
    {
        hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
        if(execScripts(hiddenDiv, a)=="retry")
            return "retry";
    }
    uniqReq("getUsage", SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
    return false;
}


newItem = function (eThis, prompt, cmd, def) {
    var li = findParentByTag(eThis, "LI");
    var path = buildPath(li, ",");
    abortReq(path);
    var newName=window.prompt(prompt, def);
    if (newName != null) {
        var data = "&command=" + cmd +"&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(newName)+"&";
	
        if(li){
            var Handler = function(Request)
            {
                hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                if(execScripts(hiddenDiv)=="retry")
                    return "retry";
                updateDepDir(li);
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
        }
    }
    return false;
}

applyCfg = function (eThis) {
    var li = findParentByTag(eThis, "LI");
    var path = buildPath(li, ",");
    var confirm=window.confirm(getHelp("webBtnApplyCfgConfirm"));
    
    if (confirm ) {
	abortReq(path);
	var data = "&command=applyConf&path={"+encodeURIComponent(path)+"}&";
	
	if(li){
            var Handler = function(Request)
            {
		hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
		if(execScripts(hiddenDiv)=="retry")
                    return "retry";
		updateDepDir(li);
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler));
	}
    }
}

saveCfg = function (eThis) {
	  var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    abortReq(path);
    var data = "&command=saveConf&path={"+encodeURIComponent(path)+"}&";

    if(li){
        var Handler = function(Request)
        {
            hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
            if(execScripts(hiddenDiv)=="retry")
                return "retry";
        }
        uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
    }
    return false;
}

setLocale = function (eThis) {
    var data = "&command=setLocale&locale=" + eThis.value + "&";
    window.LOCALE = eThis.value;
    abortReq("locale");
    var Handler = function(Request)
    {
        hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
        if(execScripts(hiddenDiv)=="retry")
            return "retry";
    }
    uniqReq("locale", SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
}

getManual= function (eThis) {
	  var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    var data = "&command=getManual&path={"+encodeURIComponent(path)+"}&";

    if(li){
        var Handler = function(Request)
        {
            hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
            if(execScripts(hiddenDiv)=="retry")
                return "retry";
        }
        SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry");
    }
    return false;
}

Edit = function (eThis) {
    var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    abortReq(path);
    var data = "&command=edit&path={"+encodeURIComponent(path)+"}&";

    if(li){
        var dir = findChildByTagClass(li, "div", "dir", 3);
        if(dir) {
            var Handler = function(Request)
            {
                dir.innerHTML = eval(zeroOrText(xmlTransform(Request)).replace(/[\r\n]*/gm,'').replace(/^.*?('<div)/mi,"$1"));
		UnHide(eThis, 1);
                if(execScripts(dir)=="retry")
                    return "retry";
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
        }
    }
    return false;
}

validateCfg = function (eThis) {
    var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    abortReq(path);
    var text = findChildByTagClass(li, "textarea", "edit", 10);
    var data = "&command=validate&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(text.value) + "&";

    if(li){
        var dir = findChildByTagClass(li, "div", "dir", 3);
        if(dir) {
            var Handler = function(Request)
            {
                hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                if(execScripts(hiddenDiv)=="retry")
                    return "retry";
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
        }
    }
    return false;
}

clearDir = function (eThis) {
    var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    var confirm=window.confirm(getHelp("webBtnClearDirConfirm"));

    if (confirm ) {
        var data = "&command=paste&path={"+encodeURIComponent(path)+"}&value=&";
        abortReq(path);
        if(li){
            var dir = findChildByTagClass(li, "div", "dir", 3);
            if(dir) {
                var Handler = function(Request)
                {
                    hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                    if(execScripts(hiddenDiv,dir)=="retry")
                        return "retry";
                }
                uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
            }
        }
    }
    return false;
}

saveEditCfg = function (eThis) {
    var li = findParentByTag(eThis, "LI");
 	  var path = buildPath(li, ",");
    abortReq(path);
    var text = findChildByTagClass(li, "TEXTAREA", "edit", 10);
    var data = "&command=paste&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent(text.value) + "&";

    if(li){
        var dir = findChildByTagClass(li, "div", "dir", 3);
        if(dir) {
            var Handler = function(Request)
            {
                hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                if(execScripts(hiddenDiv, dir)=="retry")
                    return "retry";
            }
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
        }
    }
    return false;
}


setValue = function (eThis, nil) {
    var li = findParentByTag(eThis, "LI");
    //after removing li has now parent, but may cose some events..
    if(! li.parentNode)
        return;

    var td =  findChildByTagClass(li, "td","value", 10);
    var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
    var name = findChildByTagClass(td, "INPUT", "value",  11, "UL"); 
    var path = buildPath(li, ",");
    abortReq(path);

    var data = "&command=setValueSmart&path={"+encodeURIComponent(path)+"}&";
    
    data = data + ((name && name.value == "" || nil==true) ? "" : "value="+encodeURIComponent(name.value)+"&");

    if(li){
        var Handler = function(Request)
        {
            hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
            
            var newLi = findChildByTag(hiddenDiv,"LI", 2);
            if (newLi) {
                eThis.onblur = null;
                li.parentNode.replaceChild(newLi, li);
            }
            if(execScripts(hiddenDiv)=="retry")
                return "retry";
            updateDep(newLi);
        }
  	uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
    }
}

inLineOnBlur = function (eThis, _class){
    var spanContainer = findParentByTagClass(eThis, "span", "edit", 4);
    if(spanContainer){
        var value = findChildByTagClass(spanContainer, "input", "value", 4);
        var input = findInline(spanContainer);
        var help = "header=[webEditHelp] ";
        if  (input.nodeName.toUpperCase() == "TEXTAREA") {
            input.value = '"' + input.value.replace(/\r\n/gm,'\\n').replace(/\n\r/gm,'\\n').replace(/[\n\r]/gm,'\\n').replace(/\\*"/gm, 
								       function(str){
									   if(str.length %2 == 1)
									       return str.replace(/"/gm,'\\"');
									   else
									       return str;
								       }) + '"';
        }
        
	value.value = input.value;
       
        if(typeof value.nsgTitle == 'undefined')
            value.title = help;
        else
            value.nsgTitle = help;
        if (!_class) _class = "reload";

	$(spanContainer).removeClass("reload normal disabled edit").addClass(_class);
    }
}

executeTask = function (eThis, mode) {
	  var li = findParentByTag(eThis, "LI");
	  $(li).removeClass("cl ex").addClass("ex");
	  var dir = findChildByTagClass(li, "div", "dir", 3);
    var td =  findChildByTagClass(li, "td","value", 10);
    var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
	  var name = findChildByTagClass(td, "INPUT", "value",  11, "UL"); 
    var data;
	  var path = buildPath(li, ",");
	  var ctrlPath = buildPath(li, "."); // for web tty!!!
    var Handler;
    abortReq(path);

    if ((mode== "interactive") && ($(eThis).hasClass("bstop"))) { 
        $(eThis).removeClass("bstop bexec").addClass('bexec');
        if( taskArray[".dynamic." + ctrlPath]){
            taskArray[".dynamic." + ctrlPath].kbd_buffer =  taskArray[".dynamic." + ctrlPath].kbd_buffer + "%%%";
        }
        return false;
    }
    else {
        data = "&command=executeTask&path={"+encodeURIComponent(path)+"}&value="+encodeURIComponent((name ? name.value : ""))+"&";
        if(dir) {
            var scroll = window.scrollTop;
            dir.innerHTML = "<img  class=\"loading\" src=\"/loading.gif\">" +getHelp("pleaseWait");
            /*handler start*/
            Handler = function(Request) {
                hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
                var response = getText(hiddenDiv);
                //alert("handler:"+response);
                if (mode == "interactive" && (response.length==0)) {
                    $(eThis).removeClass("bstop bexec").addClass('bstop');
                    dir.innerHTML =
                        "<span class='ttynote'><span class='ttynote green'>"+getHelp("webTtyOnline")+"</span>&nbsp;"+getHelp("webTtyCtrlKey")+"</span>" +
                        "<div class='dynamicdiv' id='.dynamic." + ctrlPath + "'>" +
                        "</div>";
                    if( taskArray[".dynamic." + ctrlPath]){
                        taskArray[".dynamic." + ctrlPath].cleanup();
                    }
                    taskArray[".dynamic." + ctrlPath] = init_webtty_object(".dynamic." + ctrlPath, function(){
			$(eThis).removeClass("bstop bexec").addClass('bexec');
                    });
                    
                } else {
                    if(response.length > 0) {
                        if (getDep(li)) {
                            alert(response);
                        }
                        else {
                            var rows = 1+response.split("\n").length;
                            dir.innerHTML = "<textarea wrap=off class=\"readonly\" readonly cols=\"80\" rows=\""+
                                (rows > 2 ? (rows < 25 ? rows : 25) : 2)+
                                "\" "+
                                // "ondblclick=\"UnHide(this);\""+
                                ">" + response + "</textarea>";
                            var text_area = findChildByTag(dir,"textarea",4);
                            text_area.scrollTop = text_area.scrollHeight;
                        };
                    } else {
                        dir.innerHTML = "";
                    }
                }
                if(execScripts(hiddenDiv)=="retry")
                    return "retry";
                hiddenDiv.innerHTML = "";
                window.scrollTop = scroll;
                updateDep(li);
		
            }
            /*handler end*/
            //alert("startHandler");
            uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry"));
        }
    }
    return false;
};

getLiClasses = function (top) {
	  var liList=top.getElementsByTagName("li");
	  var li;
	  var i;
	  var data = "";
	  for ( i = 0; i< liList.length; i++) {
		    li = liList.item(i);
		    if( li && (getAttribute(li, 'name') != "")
            && $(li).hasClass("ex")) {
            data = data + encodeURIComponent("LC" + buildPath(li,".")) + "=&";
		    }
	  }
	  return data;
};

loadDir = function (li, clearCache, extra) {
    if (li.nodeName.toUpperCase() != "LI")
        li = findParentByTag(li, "LI",10);

	  var dir = findChildByTagClass(li, "div", "dir", 3);
    if(dir) {
        var scroll = window.scrollTop;
        var Handler = function(Request)
        {
            dir.innerHTML = zeroOrText(xmlTransform(Request));
            if(execScripts(dir)=="retry")
                return "retry";
            $(dir).removeClass("loading");
            window.scrollTop = scroll;
	    updateValues();
        }

        var path = buildPath(li, ",");
        var data = "&command=getConf&path={"+encodeURIComponent(path)+"}&"+ getLiClasses(li);
        if ((typeof(clearCache ) != "undefined") && clearCache)
            data = data + "&clearcache=&";
        if ((typeof(extra ) != "undefined") && extra)
            data = data + "&extra=" + encodeURIComponent(extra) + "&";

        $(dir).addClass("loading");
        SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry");
    }
    return false;
}

getDep = function (li) {
    return findChildByTagClass(li, "input","dep", 7);
}

findDepDir = function (li, lis){
    var dep;
    if(! /^[a-zA-Z].*$/.test(li.nodeName)) {
        return 0;
    }
    if (li.nodeName.toUpperCase() == "LI") {
        dep = getDep(li);
    }
    if (dep != null) {
        if (dep.value==0) {
            lis[lis.length] = li;
            return 0;
        } else if(dep.value>0) {
            return -dep.value;
        }
        return 0;
    } else {
        var tlis = new Array();
        for (var i = 0 ; i < li.childNodes.length; i++) {
            var tli = li.childNodes.item(i);
            if (tli &&  /^[a-zA-Z].*$/.test(tli.nodeName)) {
                var ret = findDepDir(tli, tlis);
                if (ret < -1) {
                    return ret+1;
                } else if(ret == -1) {
                    lis[lis.length] = li;
                    return 0;
                }
            }
        }
        for (var i = 0 ; i < tlis.length; i++) {
            lis[lis.length] = tlis[i];
        }
        return 0;
    }
}

updateDepDir = function (li) {
    if (!li) return;

    if (li.nodeName.toUpperCase() != "LI") {
        li = findParentByTag(li,'LI');
    }
    var lis= new Array();
    var dep = findDepDir(li, lis);
    if (dep<0) {
        for(;
            dep < 0 && li && ! $(li).hasClass("root");
            dep = dep + 1) {
            li = findParentByTag(li, "LI");
        };
        lis = new Array(li);
    }
    for ( i = 0 ; i < lis.length; i++) {
        if (! findChildByTagClass(lis[i], "input","pleasewait", 4)) {
            loadDir( lis[i], true);
        }
    }
    updateValues();
}

updateDep = function (li) {
    if (li.nodeName.toUpperCase() != "LI") {
        li = findParentByTag(li,'LI');
    }
    var dep = getDep(li);
    if (dep) {
        for(dep = dep.value;
            dep > 0 && li && ! $(li).hasClass("root");
            dep = dep - 1) {
            li = findParentByTag(li, "LI");
        };
        if (li)
            loadDir(li, true);
    }
    updateValues();
}

uniqReq = function (name, request){
    if(validatorRequestArray[name]) {
        validatorRequestArray[name].abort();
    }
    validatorRequestArray[name] = request;
}

abortReq = function (name){
    uniqReq(name, null);
}

getHTML = function (li, module) {
    if (li.nodeName.toUpperCase() != "LI")
        li = findParentByTag(li, "LI",10);
    var path = buildPath(li, ",");
    var data = "&command=getHTML&subcmd=start&path={"+encodeURIComponent(path)+"}&";

    hiddenDiv.innerHTML =
        "<form name=\"nsghiddenform\" id=\"nsghiddenform\" method=\"post\" target=\"_blank\" >" +
        "<input type=\"hidden\" name=\"command\" value=\"getHTML\">"+
        "<input type=\"hidden\" name=\"module\" value=\""+module+"\">"+
        "<input type=\"hidden\" name=\"subcmd\" value=\"start\">"+
        "<input type=\"hidden\" name=\"maxRights\" value=\"user\">"+
        "<input type=\"hidden\" name=\"locale\" value=\""+window.LOCALE+"\">"+
        "<input type=\"hidden\" name=\"path\" value=\"{"+htmlEncode(path)+"}\">"+
        "<input type=\"hidden\" name=\"login\" value=\""+htmlEncode(window.LOGIN)+"\">"+
        "<input type=\"hidden\" name=\"netns\" value=\""+htmlEncode(window.NETNS)+"\">"+
        "<input type=\"hidden\" name=\"pass\" value=\""+htmlEncode(window.PASSWORD)+"\">"+
        "<input type=\"submit\">"+
        "</form>";

    var form =  findChildByTag(hiddenDiv,"form",10);
    form = hiddenDiv.removeChild(form);
    var body = findChildByTag(document,"body", 10);
    body.appendChild(form);
    form.submit();
    body.removeChild(form);
    return false;
}


logOut = function (force) {
	  var Handler = function(Request)
    {
        hiddenDiv.innerHTML =  zeroOrText(xmlTransform(Request));
        if(execScripts(hiddenDiv)=="retry")
            return "retry";
    }

	  var data = "&command=logOut";
    if(force)
        data = data + "&force=true";
	  SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler, "retry");
}

valueKeyDown = function (e,eThis) {
    var key = 0;
    if (!e) var e = window.event;
    if (e.keyCode) key = e.keyCode;
    else if (e.which) key = e.which;
    if (key==13) //Enter 
    {
        startEdit(eThis);
        return false;
    }
}

btnKeyDown = function (e,eThis) {
    var key = 0;
    if (!e)
	e = window.event;

    if (e.keyCode) key = e.keyCode;
    else if (e.which) key = e.which;

    if (key==13) //Enter
    {
        eThis.onclick();
        return false;
    }
}

inLineKeyDown = function (e,eThis) {
    var key = 0;
    if (!e) 
	e = window.event;

    if (e.keyCode) key = e.keyCode;
    else if (e.which) key = e.which;

    if (key==13 && (eThis.nodeName.toUpperCase() != "TEXTAREA" || e.ctrlKey)) //Enter
    {
        eThis.onblur();
        return false;
    }
    else if (key==27) //Escape
    {
        stopEdit(eThis);
        return false;
    }
}


//key down on param name
paramKeyDown = function(e,eThis) {
    var key = 0;
    var li = findParentByTag(eThis, "LI");
    var td =  findChildByTagClass(li, "td","param", 10);
    var stype = findChildByTagClass(td, "INPUT", "stype",  11, "UL");
    var ewe = false;
    if (!e)
	e = window.event;
    
    if (e.keyCode) key = e.keyCode;
    else if (e.which) key = e.which;

    if (key==13) //Enter
    {
        if (stype && stype.value=="dir") {
            // UnHide(eThis);
        }
        else {
            td =  findChildByTagClass(li, "td","value", 10);
            var input =   findChildByTagClass(td, "input","value", 10);
            startEdit(input);
        }
        return false;
    }
    else if (key==37) // left
    {
        if ((stype && stype.value=="dir") && ($(li).hasClass("ex")))
            UnHide(eThis, 0); //collapse
        else { // go to parent
            li =  findParentByTag(li, "LI");
            if (li) {
                td =  findChildByTagClass(li, "td","param", 10);
                if (td) {
                    var a =  findChildByTagClass(td, "a","name", 10);
                    if(a)
                        a.focus();
                }
            }
        }
        return false;
    }
    else if (key==39) // right
    {
        if ((stype && stype.value=="dir") && (! UnHide(eThis, 1))) {// expand 
            var dir =  findChildByTagClass(li, "div","dir", 10);
            if (dir) {
                var a =  findChildByTagClass(dir, "a","name", 10);
                if (a)
                    a.focus();
            }
        }
        return false;
    }
    
    if (key==38) // top
    {
        var prevLi = findPrevSibling( li, "LI");
        if (prevLi) {
            var  ul = findChildByTag(prevLi, "UL", 10);
            for(;prevLi && $(prevLi).hasClass("ex") && findChildByTag(ul, "LI", 3);) {
                prevLi = ul.lastChild;
                if (prevLi && (!prevLi.nodeName || (prevLi.nodeName.toUpperCase() != "LI")))
                    prevLi = findPrevSibling(prevLi, "LI");
                ul = findChildByTag(prevLi, "UL", 10);
            }
        } else {
            prevLi =  findParentByTag(li, "LI");
        }
        if (prevLi && prevLi.nodeName && prevLi.nodeName.toUpperCase()== "LI") {
            td =  findChildByTagClass(prevLi, "td","param", 10);
            if (td) {
                var a =  findChildByTagClass(td, "a","name", 10);
                if(a)
                    a.focus();
            }
        }
        return false;
    }
    else if (key==40) //down
    {
        var  nextLi =  findChildByTag(findChildByTag(li, "UL", 10), "LI", 10);
        if ($(li).hasClass("expanded") &&  nextLi){
        } else {
            nextLi = li;
            for(;nextLi && !findSibling(nextLi, "LI");) {
                nextLi = findParentByTag( nextLi, "LI");
            }
            nextLi = findSibling(nextLi, "LI");
        }
        if(nextLi) { 
            td =  findChildByTagClass(nextLi, "td","param", 10);
            if (td) {
                var a =  findChildByTagClass(td, "a","name", 10);
                if(a)
                    a.focus();
            }
        }
        return false;
    }
}


f_clientWidth = function () {
	  return f_filterResults (
		    window.innerWidth ? window.innerWidth : 0,
		    document.documentElement ? document.documentElement.clientWidth : 0,
		    document.body ? document.body.clientWidth : 0
	  );
}

var leakCheckerCounter = 0;
showLeakChecker = function () {
    leakCheckerCounter = leakCheckerCounter+1;
    if(leakCheckerCounter>4) {
        MemoryLeakChecker.checkLeaks();
    }
}

MemoryLeakChecker = {

    uniq_id: (new Date()).getTime(),
    checked: 1,
    is_seen: [],
    checkLeaks: function() {
        var self = MemoryLeakChecker;
        console.log(' ');
        console.log('Start CheckLeaks');
        console.log(' ');
        self.checked=1;
        self.is_seen=[];
        self.uniq_id = (new Date()).getTime();
        self._checkLeaks(window, 'window');
    },
    _checkLeaks: function(obj, key) {
        var self = MemoryLeakChecker;

        if(!obj || (typeof obj == 'function') || self.checked > 20000)
            return ;

        if((self._isArray(obj) || self._isObject(obj))) {
            if(self._isArray(obj)) {
                self._logTooBig(obj, obj.length, key)
                for(var i=0; i < obj.length; i++) {
                    self._checkIfNeeded(obj[i], key + '[' + i +"]")
                }
            }
            else if(self._isObject(obj)) {
                self._logTooBig(obj, self._keys(obj).length, key)

                for(var keyy in obj) {
                    try {
                        self._checkIfNeeded(obj[keyy],  key + '.' +keyy);
                    } catch(e) {}
                }
            }
        }
    },

    _checkIfNeeded: function(obj, key) {
        if(obj==null || obj==undefined )
            return ;

        var self = MemoryLeakChecker;
        self.checked++

        if((self._isArray(obj) || self._isObject(obj))) {
            try {
                if(obj.__leaks_checked == self.uniq_id)
                    return ;
                obj.__leaks_checked = self.uniq_id

                setTimeout(self._partial(self._checkLeaks, obj, key), 5);
            } catch(e) {
                //locked obj..  skip it
            }
        }
    },

    _logTooBig: function(obj, limit, key) {
        if(limit > 300) {
            console.log('Object too big, memory leak? [size: ' + limit + ']')
            console.log("path:"+key);
            console.log(obj)
            console.log('-------')
        }
    },

    _keys: function(obj) {
        var rval = [], prop
        for(prop in obj)
            rval.push(prop)
        return rval
    },

    _isArray: function(obj) {
        try {
            return obj instanceof Array
        }
        catch(e) {
            return false
        }
    },

    _isObject: function(obj) {
        return (typeof obj == 'object')
    },

    _partial: function(fn) {
        var args = Array.prototype.slice.call(arguments)
        args.shift()
        return function() {
            var new_args = Array.prototype.slice.call(arguments)
            args = args.concat(new_args)
            return fn.apply(window, args)
        }
    }
}

function loadJSTo(src, doc) {

    function loadDynamic (src, doc){
        with (doc) {
            node = createElement("script");
            node = getElementsByTagName("head")[0].appendChild(node);
            node.setAttribute("type","text/javascript");
            node.setAttribute("src",arguments[0])
        }
    }

    function combinedWindowOnload(){
	      if(arguments.callee.done){return}
	      arguments.callee.done=true;
	      if(doc.getElementsByTagName){
            /* Safari */
	          if(!/WebKit/i.test(navigator.userAgent)){
                /* IE */
		            setTimeout(function () {loadDynamic(src, doc); },0);
	          }
        }
    }
    
    /*  Safari  */
    if(/WebKit/i.test(navigator.userAgent)){
        loadDynamic(src, doc);
    }

    combinedWindowOnload()
}

function loadCSSTo(src, doc) {

    function loadDynamic (src, doc){
        var node=doc.createElement("link");
        node = doc.getElementsByTagName("head")[0].appendChild(node);

	      node.setAttribute("rel","stylesheet");
	      node.setAttribute("media","all")
        
        node.setAttribute("type","text/css");
        node.setAttribute("href",src)
    }

    function combinedWindowOnload(){
	      if(arguments.callee.done){return}
	      arguments.callee.done=true;
	      if(doc.getElementsByTagName){
            /* ÎÅ Safari */
	          if(!/WebKit/i.test(navigator.userAgent)){
                /* IE */
		            setTimeout(function () {loadDynamic(src, doc); },0);
	          }
        }
    }
    
    /*  Safari  */
    if(/WebKit/i.test(navigator.userAgent)){
        loadDynamic(src, doc);
    }

    combinedWindowOnload()
}



var oldAlert = window.alert;

window.alert = function ( message ) {
    function viewSize() {
        var myWidth = 0, myHeight = 0;
        if( typeof( window.innerWidth ) == 'number' ) {
            //Non-IE
            myWidth = window.innerWidth;
            myHeight = window.innerHeight;
        } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
            //IE 6+ in 'standards compliant mode'
            myWidth = document.documentElement.clientWidth;
            myHeight = document.documentElement.clientHeight;
        } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
            //IE 4 compatible
            myWidth = document.body.clientWidth;
            myHeight = document.body.clientHeight;
        }
        return {width: myWidth ,
                height: myHeight };
    }

	  if ( $('div.alert-wrapper').length ) {
			  $('div.alert-wrapper').remove();
	  }

	  $('<div class="alert-wrapper"><div class="alert-shadow"></div><div class="alert-box"></div></div>').appendTo('body');

	  var wrapper = $('div.alert-wrapper');
	  var shadow = $('div.alert-shadow').hide();
	  var box = $('div.alert-box').hide();

    var rows = 1 + message.split("\n").length;
	  var inner = '<div class="alert-box-container"><div class="alert-box-message">' + message + '</div><div class="alert-box-input"><input type="button" value="OK" /></div></div>';

		shadow.css({opacity: 0.1}).fadeIn(300);
		box.html(inner).fadeIn(300);

		if ( $.browser.msie && $.browser.version<8 ) {
				// IE6/7
			  var css = ({
				    position: "absolute",
				    height: $(document).height() + "px",
				    width: $(document).width() + "px"
			  });
			  wrapper.css(css);
			  shadow.css(css);

			  var d = $(document);

			  box.css({
				    position: 'absolute',
				    top: d.scrollTop()+($(window).height()/2) + 'px',
				    left: d.scrollLeft()+($(window).width()/2) + 'px'
			  });
		}

    var msg = $('.alert-box-message', box)
    if(msg.width()>viewSize().width - 30) {
        msg.css({
            width:  viewSize().width - 30 + 'px'
        });
    };

    if(msg.height()>viewSize().height - 50) {
        msg.css({
            height: viewSize().height - 50 + 'px'
        });
    };

		box.css({
			  marginLeft: (-1 * (box.width()/2)) + 'px',
			  marginTop: (-1 * ( (box.height()/2))) + 'px'
		});

	  var closer = function (){
		    shadow.fadeOut(300);
		    box.fadeOut(300, function(){
			      wrapper.remove();
		    });
	  }
		$(document).one('keydown', function(e) {
				if(e.which==27) closer();
		});

	  box.find('input[type="button"]').click(closer);
	  shadow.click(closer);

		// autoClose
	  //setTimeout(closer, 7000);

}

reloadNsg = function() {
    
    var form = $('<form/>', {
        method: 'POST',
        style: {
            display: 'none'
        }
    });
    
    form.append($('<input/>',{
        type: 'hidden',
        name: 'login',
        value:window.LOGIN
    })).append($('<input/>',{
        type: 'hidden',
        name: 'pass',
        value:window.PASSWORD
    })).append($('<input/>',{
        type: 'hidden',
        name: 'netns',
        value:window.NETNS
    })).append($('<input/>',{
        type: 'hidden',
        name: 'command',
        value:'login'
    }));
    
    form.appendTo(document.body); // Необходимо для некоторых браузеров
    form.submit();
    
    
}

recalcAUTH = function() {
    var login = (window.LOGIN != "" ? "login=" + encodeURIComponent(window.LOGIN) : "");
    var password = (window.PASSWORD != "" ? "pass=" + encodeURIComponent(window.PASSWORD) : "");
    var netns = "netns=" + encodeURIComponent(window.NETNS);
    var sesnum = (window.LOGIN != "" ? "sesnum."+encodeURIComponent(window.NETNS)+"."+encodeURIComponent(window.LOGIN)+"=" + encodeURIComponent(window.SID) : "")

    window.AUTH=
        "mode=xml"
        + "&" + login
        + "&" + sesnum
        + "&" + netns
        + "&" + password;
}

loginNSG = function (eThis) {
    delCookie('netns');
    delCookie('sesnum.' + window.NETNS +"." + window.LOGIN );
    delCookie('login');

	  var path = "login";
    window.LOGIN = ($("#login").length==1 ? $("#login").val() : window.LOGIN );
    window.NETNS =  ($("#netns").length==1 ? $("#netns").val() : window.NETNS );
    window.LOCALE =  ($("#locale").length==1 ? $("#locale").val() : window.LOCALE);
    window.PASSWORD =  ($("#pass").length==1 ? $("#pass").val() : window.PASSWORD);

    var pass = ($("#password").length==1 ? ("&pass="+$("#password").val()) : "");
    var locale = ($("#locale").length==1 ? ("&locale="+$("#locale").val()) : "");
    recalcAUTH();
//    window.PASSWORD = "";
    var data = "&command=start&timeout=60" + pass + locale;
    var Handler = function(Request)
    {
        $("body div.main").html(zeroOrText(xmlTransform(Request)));
	initScript();
        if(execScripts($("body")[0])=="retry")
            return "retry";
    }
    uniqReq(path, SendRequestAsync("post", window.location.toString()/*PAGENAME*/, data, Handler,"retry"));
}

var speedlimit=1500;
var scrolldelay=500;
var scrollIt = function(div){
    div = $(div);
    div.html('<nobr>'+div.html()+'</nobr>');
    var nobr =  div.find('nobr');
    nobr.css({position:'absolute',left:0,top:0});
    var width=nobr.width();
    var widthContainer=div.width();
    var speed=speedlimit*(width/widthContainer);
    if(width > widthContainer){
	scrollforward(nobr, width, widthContainer, speed);
    }
}

var scrollforward=function(nobr, w, wc, speed){
			nobr.delay(scrolldelay).animate({left:-(w-wc)},speed,function(){scrollbackward(nobr, w, wc, speed);});
}

var scrollbackward=function(nobr, w,wc,speed){
			nobr.delay(scrolldelay).animate({left:0},speed,function(){
			scrollforward(nobr, w, wc, speed);
			});
}

var luaReserved ={
    "and" : true,
    "break" : true,
    "do" : true,
    "else": true,
    "elseif" : true,
    "end" : true,
    "false" : true,
    "for" : true,
    "function" : true,
    "if" : true,
    "in" : true,
    "local" : true,
    "nil" : true,
    "not" : true,
    "or" : true,
    "repeat" : true,
    "return" : true,
    "then" : true,
    "true" : true,
    "until" : true,
    "while" : true
};

var luaName = function(s){
    if (s.search(/^".*"$/)>-1){
	//lua string
	var cs = s.replace(/"(.*)"/mg,"$1");
	if(cs.search(/^[0-9]/)>-1 || cs.search(/[\\ -]/)>-1 || luaReserved[cs]) {
	    return "["+s+"]";
	} else {
	    return cs;
	}
    }else {
	// not lua string
	if (s.search(/^[0-9]+$/)>-1)
	    return "["+s+"]";
	else
	    return s;
    }
}

var updateValues = function(node) {
    var value=false;
    var loadedTree= false;
    $("ul.config:first", node).children("li").each(
	function (i, li) {
	    loadedTree = true;
	    var param = updateValues(li);
	    if (param >"")
		value = (value ? (value+",\n") : "")  + luaName(getAttribute(li, "name"))+" = "+param+"\n";
	}
    );
    if (value) {
	value =  "{\n"+value+"}\n";
	setParamValue(node, value);
    }
    else if(loadedTree) {
	if($("table.node:first td.param input.usernode", node).val()=="1") {
	    setParamValue(node, "{}");
	    value = "{}";
	}
	else {
	    setParamValue(node, "");
	}
    }
    else {
	value = paramValue(node);
    }
    
    return value;
}


decActivity();

//initScript();
